package netscape.plugin.composer;

class PluginRunner implements Runnable {
   private Plugin plugin;
   private ComposerDocument document;
   private PluginManager manager;

   public PluginRunner(Plugin var1, ComposerDocument var2, PluginManager var3) {
      this.plugin = var1;
      this.document = var2;
      this.manager = var3;
   }

   public void run() {
      Composer var1 = this.document.getComposer();

      try {
         boolean var2 = this.plugin.perform(this.document);
         this.manager.pluginFinished(var1, var2 ? 2 : 1, (Object)null);
      } catch (ThreadDeath var3) {
         System.err.println("Composer plugin " + this.plugin + " was killed.");
      } catch (Throwable var4) {
         System.err.println("Composer plugin " + this.plugin + " threw this exception:");
         var4.printStackTrace();
         this.manager.pluginFinished(var1, 0, var4.toString());
      }
   }
}
