package netscape.plugin.composer.io;

import java.util.Enumeration;

public class Entity extends Token {
   private String name;
   // $FF: renamed from: ch int
   private int field_0;
   private static Entity[] knownEntities = new Entity[106];

   public Entity(StringBuffer var1) {
      this.name = var1.toString();
      this.field_0 = -1;
   }

   public static Enumeration entities() {
      return new EntityEnumeration(knownEntities);
   }

   Entity(FooStringBuffer var1) {
      this.name = var1.toString();
      this.field_0 = -1;
   }

   public Entity(String var1, char var2) {
      this.name = var1;
      this.field_0 = var2;
   }

   public int getValue() {
      if (this.field_0 == -1) {
         this.field_0 = this.evaluate();
      }

      return this.field_0;
   }

   protected int evaluate() {
      try {
         if (this.name.charAt(0) == '#') {
            int var6 = 0;
            int var2 = this.name.length();

            for(int var3 = 1; var3 < var2; ++var3) {
               char var4 = this.name.charAt(var3);
               if (var4 < '0' || var4 > '9') {
                  break;
               }

               var6 = var6 * 10 + (var4 - 48);
            }

            return var6;
         }

         for(int var1 = 0; var1 < knownEntities.length; ++var1) {
            if (knownEntities[var1].name.equals(this.name)) {
               return knownEntities[var1].field_0;
            }
         }
      } catch (ArrayIndexOutOfBoundsException var5) {
      }

      return -1;
   }

   public String toString() {
      return "&" + this.name + ";";
   }

   public int hashCode() {
      if (this.field_0 == -1) {
         this.field_0 = this.evaluate();
      }

      return this.name.hashCode() ^ this.field_0;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof Entity) {
         Entity var2 = (Entity)var1;
         return this.name.equals(var2.name);
      } else {
         return false;
      }
   }

   static {
      int var0 = 0;
      knownEntities[var0++] = new Entity("lt", '<');
      knownEntities[var0++] = new Entity("LT", '<');
      knownEntities[var0++] = new Entity("gt", '>');
      knownEntities[var0++] = new Entity("GT", '>');
      knownEntities[var0++] = new Entity("amp", '&');
      knownEntities[var0++] = new Entity("AMP", '&');
      knownEntities[var0++] = new Entity("quot", '"');
      knownEntities[var0++] = new Entity("QUOT", '"');
      knownEntities[var0++] = new Entity("nbsp", ' ');
      knownEntities[var0++] = new Entity("reg", '®');
      knownEntities[var0++] = new Entity("REG", '®');
      knownEntities[var0++] = new Entity("copy", '©');
      knownEntities[var0++] = new Entity("COPY", '©');
      knownEntities[var0++] = new Entity("iexcl", '¡');
      knownEntities[var0++] = new Entity("cent", '¢');
      knownEntities[var0++] = new Entity("pound", '£');
      knownEntities[var0++] = new Entity("curren", '¤');
      knownEntities[var0++] = new Entity("yen", '¥');
      knownEntities[var0++] = new Entity("brvbar", '¦');
      knownEntities[var0++] = new Entity("sect", '§');
      knownEntities[var0++] = new Entity("uml", '¨');
      knownEntities[var0++] = new Entity("ordf", 'ª');
      knownEntities[var0++] = new Entity("laquo", '«');
      knownEntities[var0++] = new Entity("not", '¬');
      knownEntities[var0++] = new Entity("shy", '\u00ad');
      knownEntities[var0++] = new Entity("macr", '¯');
      knownEntities[var0++] = new Entity("deg", '°');
      knownEntities[var0++] = new Entity("plusmn", '±');
      knownEntities[var0++] = new Entity("sup2", '²');
      knownEntities[var0++] = new Entity("sup3", '³');
      knownEntities[var0++] = new Entity("acute", '´');
      knownEntities[var0++] = new Entity("micro", 'µ');
      knownEntities[var0++] = new Entity("para", '¶');
      knownEntities[var0++] = new Entity("middot", '·');
      knownEntities[var0++] = new Entity("cedil", '¸');
      knownEntities[var0++] = new Entity("sup1", '¹');
      knownEntities[var0++] = new Entity("ordm", 'º');
      knownEntities[var0++] = new Entity("raquo", '»');
      knownEntities[var0++] = new Entity("frac14", '¼');
      knownEntities[var0++] = new Entity("frac12", '½');
      knownEntities[var0++] = new Entity("frac34", '¾');
      knownEntities[var0++] = new Entity("iquest", '¿');
      knownEntities[var0++] = new Entity("Agrave", 'À');
      knownEntities[var0++] = new Entity("Aacute", 'Á');
      knownEntities[var0++] = new Entity("Acirc", 'Â');
      knownEntities[var0++] = new Entity("Atilde", 'Ã');
      knownEntities[var0++] = new Entity("Auml", 'Ä');
      knownEntities[var0++] = new Entity("Aring", 'Å');
      knownEntities[var0++] = new Entity("AElig", 'Æ');
      knownEntities[var0++] = new Entity("Ccedil", 'Ç');
      knownEntities[var0++] = new Entity("Egrave", 'È');
      knownEntities[var0++] = new Entity("Eacute", 'É');
      knownEntities[var0++] = new Entity("Ecirc", 'Ê');
      knownEntities[var0++] = new Entity("Euml", 'Ë');
      knownEntities[var0++] = new Entity("Igrave", 'Ì');
      knownEntities[var0++] = new Entity("Iacute", 'Í');
      knownEntities[var0++] = new Entity("Icirc", 'Î');
      knownEntities[var0++] = new Entity("Iuml", 'Ï');
      knownEntities[var0++] = new Entity("ETH", 'Ð');
      knownEntities[var0++] = new Entity("Ntilde", 'Ñ');
      knownEntities[var0++] = new Entity("Ograve", 'Ò');
      knownEntities[var0++] = new Entity("Oacute", 'Ó');
      knownEntities[var0++] = new Entity("Ocirc", 'Ô');
      knownEntities[var0++] = new Entity("Otilde", 'Õ');
      knownEntities[var0++] = new Entity("Ouml", 'Ö');
      knownEntities[var0++] = new Entity("times", '×');
      knownEntities[var0++] = new Entity("Oslash", 'Ø');
      knownEntities[var0++] = new Entity("Ugrave", 'Ù');
      knownEntities[var0++] = new Entity("Uacute", 'Ú');
      knownEntities[var0++] = new Entity("Ucirc", 'Û');
      knownEntities[var0++] = new Entity("Uuml", 'Ü');
      knownEntities[var0++] = new Entity("Yacute", 'Ý');
      knownEntities[var0++] = new Entity("THORN", 'Þ');
      knownEntities[var0++] = new Entity("szlig", 'ß');
      knownEntities[var0++] = new Entity("agrave", 'à');
      knownEntities[var0++] = new Entity("aacute", 'á');
      knownEntities[var0++] = new Entity("acirc", 'â');
      knownEntities[var0++] = new Entity("atilde", 'ã');
      knownEntities[var0++] = new Entity("auml", 'ä');
      knownEntities[var0++] = new Entity("aring", 'å');
      knownEntities[var0++] = new Entity("aelig", 'æ');
      knownEntities[var0++] = new Entity("ccedil", 'ç');
      knownEntities[var0++] = new Entity("egrave", 'è');
      knownEntities[var0++] = new Entity("eacute", 'é');
      knownEntities[var0++] = new Entity("ecirc", 'ê');
      knownEntities[var0++] = new Entity("euml", 'ë');
      knownEntities[var0++] = new Entity("igrave", 'ì');
      knownEntities[var0++] = new Entity("iacute", 'í');
      knownEntities[var0++] = new Entity("icirc", 'î');
      knownEntities[var0++] = new Entity("iuml", 'ï');
      knownEntities[var0++] = new Entity("eth", 'ð');
      knownEntities[var0++] = new Entity("ntilde", 'ñ');
      knownEntities[var0++] = new Entity("ograve", 'ò');
      knownEntities[var0++] = new Entity("oacute", 'ó');
      knownEntities[var0++] = new Entity("ocirc", 'ô');
      knownEntities[var0++] = new Entity("otilde", 'õ');
      knownEntities[var0++] = new Entity("ouml", 'ö');
      knownEntities[var0++] = new Entity("divide", '÷');
      knownEntities[var0++] = new Entity("oslash", 'ø');
      knownEntities[var0++] = new Entity("ugrave", 'ù');
      knownEntities[var0++] = new Entity("uacute", 'ú');
      knownEntities[var0++] = new Entity("ucirc", 'û');
      knownEntities[var0++] = new Entity("uuml", 'ü');
      knownEntities[var0++] = new Entity("yacute", 'ý');
      knownEntities[var0++] = new Entity("thorn", 'þ');
      knownEntities[var0++] = new Entity("yuml", 'ÿ');
   }
}
